package com.zhangmeng.online.exam.ui.api.model;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONArray;
import com.alibaba.fastjson2.JSONObject;
import com.zhangmeng.online.exam.ui.api.ApiUtils;
import com.zhangmeng.online.exam.ui.api.DataLoad;
import com.zhangmeng.online.exam.ui.utils.HttpUtils;
import javafx.beans.property.SimpleStringProperty;
import javafx.scene.Parent;
import javafx.scene.control.MenuItem;
import javafx.stage.Stage;

import java.util.*;

import static com.zhangmeng.online.exam.ui.api.ApiUtils.API_URL;

/**
 * @author zm
 * @date 2025/3/14 16:19
 * @version: 1.0
 */
public class RoleDataLoad implements DataLoad {

    private Parent form;
    @Override
    public ApiUtils.DataView loadData(Integer pageNum, Integer pageSize) {
        Map<String, Object> params = new HashMap<>();
        params.put("pageNum", pageNum.toString());
        params.put("pageSize", pageSize.toString());

        String userListData = HttpUtils.GET(API_URL + "/role/list",params);
        JSONObject jsonObject = JSON.parseObject(userListData);
        JSONArray data = jsonObject.getJSONArray("data");
        Integer total = jsonObject.getInteger("total");
        List<Map<String, SimpleStringProperty>> roleMapList = new ArrayList<>();
        for (Object datum : data) {
            JSONObject role = (JSONObject) datum;
            Map<String, SimpleStringProperty> roleMap = new HashMap<>();
            roleMap.put("序号", new SimpleStringProperty(role.getString("id")));
            roleMap.put("角色名称", new SimpleStringProperty(role.getString("name")));
            roleMap.put("描述", new SimpleStringProperty(role.getString("desc")));
            roleMap.put("角色类型", new SimpleStringProperty(role.getString("type_name")));
            roleMapList.add(roleMap);
        }
        return new ApiUtils.DataView(Arrays.asList("序号", "角色名称", "描述", "角色类型"), roleMapList).setDataLoad(this).setPageNum(pageNum).setPageSize(pageSize).setTotal(total);
    }

    @Override
    public void setForm(Parent view) {
        this.form = view;
    }

    @Override
    public Parent getForm() {
        return form;
    }

    @Override
    public Map<String, Object> saveForm(Map<String, Object> map) {
        return null;
    }

    @Override
    public void deleteData(String id) {

    }

    @Override
    public void editData(String id, Stage stage) {

    }

    @Override
    public void updateData(String id, String name, String oldValue, String newValue) {

    }

    @Override
    public List<MenuItem> getContextMenu() {
        return null;
    }

    @Override
    public ApiUtils.DataView searchData(Map<String, Object> searchText, int pageNum, int pageSize) {
        return null;
    }
}
